Bug 1003156 - (kate-plugin-cpphelper) Review Request: kate-plugin-cpphelper - Plugin for Kate to simplify C/C++ programming
Review Request: kate-plugin-cpphelper - Plugin for Kate to simplify C/C++ pro...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Sandro Mani
Fedora Extras Quality Assurance
:
Depends On:
Blocks: kde-reviews
  Show dependency treegraph
 
Reported: 2013-08-31 04:47 EDT by Mario Blättermann
Modified: 2013-10-09 10:38 EDT (History)
3 users (show)

See Also:
Fixed In Version: kate-plugin-cpphelper-0.9.3-2.fc20
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-10-08 07:28:16 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
manisandro: fedora‑review+
kevin: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Mario Blättermann 2013-08-31 04:47:58 EDT
Spec URL: http://mariobl.fedorapeople.org/Review/SPECS/kate-plugin-cpphelper.spec
SRPM URL: http://mariobl.fedorapeople.org/Review/SRPMS/kate-plugin-cpphelper-0.9.3-1.fc19.src.rpm
Description:
This plugin is intended to simplify the hard life of C/C++ programmers who
use Kate to write code.
It has C++ code completion (clang based), #include files completion, smarter 
replacement for standard Open Header plugin, and few other neat features.

Fedora Account System Username: mariobl

Notes:
"Requires: kate" is actually not needed, because it would be theoretically usable through the provided kpart. If it makes sense, I don't know... However, Kate itself is not pulled in as a runtime requirement, only kate-libs:

$ rpm -qpR kate-plugin-cpphelper-0.9.3-1.fc19.x86_64.rpm
libQtCore.so.4()(64bit)
libQtDBus.so.4()(64bit)
libQtGui.so.4()(64bit)
libQtNetwork.so.4()(64bit)
libQtSvg.so.4()(64bit)
libQtXml.so.4()(64bit)
libc.so.6()(64bit)
libc.so.6(GLIBC_2.14)(64bit)
libc.so.6(GLIBC_2.2.5)(64bit)
libclang.so()(64bit)
libgcc_s.so.1()(64bit)
libgcc_s.so.1(GCC_3.0)(64bit)
libkateinterfaces.so.4()(64bit)
libkdecore.so.5()(64bit)
libkdeui.so.5()(64bit)
libkfile.so.4()(64bit)
libkio.so.5()(64bit)
libkparts.so.4()(64bit)
libktexteditor.so.4()(64bit)
libm.so.6()(64bit)
libnepomuk.so.4()(64bit)
libnepomukutils.so.4()(64bit)
libpthread.so.0()(64bit)
libpthread.so.0(GLIBC_2.2.5)(64bit)
libsoprano.so.4()(64bit)
libstdc++.so.6()(64bit)
libstdc++.so.6(CXXABI_1.3)(64bit)
libstdc++.so.6(GLIBCXX_3.4)(64bit)
rpmlib(CompressedFileNames) <= 3.0.4-1
rpmlib(FileDigests) <= 4.6.0-1
rpmlib(PayloadFilesHavePrefix) <= 4.0-1
rtld(GNU_HASH)
rpmlib(PayloadIsXz) <= 5.2-1

In that case, the folder %{_kde4_datadir}/kde4/apps/kate/plugins/ would stay unowned. That's why I've added it explicitely.
Comment 1 Sandro Mani 2013-09-25 16:55:49 EDT
Full review below. Only issue is the missing license text. As stated here [1], you should contact upstream to include a license file. In the meantime, you should probably add a copy of the GPLv3 license file.

Everything else is okay, approved!


[1] https://fedoraproject.org/wiki/Packaging:LicensingGuidelines?rd=Packaging/LicensingGuidelines#License_Text


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package installs a %{name}.desktop using desktop-file-install or desktop-
  file-validate if there is such a file.


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[-]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[-]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "*No copyright* GPL (v3 or later)", "GPL (v3)", "Unknown or generated". 2
     files have unknown license. Detailed output of licensecheck in
     /home/sandro/.Data/Desktop/1003156-kate-plugin-cpphelper/licensecheck.txt
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[!]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[?]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: kate-plugin-cpphelper-0.9.3-1.fc21.x86_64.rpm
          kate-plugin-cpphelper-0.9.3-1.fc21.src.rpm
2 packages and 0 specfiles checked; 0 errors, 0 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint kate-plugin-cpphelper
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
# echo 'rpmlint-done:'



Requires
--------
kate-plugin-cpphelper (rpmlib, GLIBC filtered):
    kate
    libQtCore.so.4()(64bit)
    libQtDBus.so.4()(64bit)
    libQtGui.so.4()(64bit)
    libQtNetwork.so.4()(64bit)
    libQtSvg.so.4()(64bit)
    libQtXml.so.4()(64bit)
    libc.so.6()(64bit)
    libclang.so()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libkateinterfaces.so.4()(64bit)
    libkdecore.so.5()(64bit)
    libkdeui.so.5()(64bit)
    libkfile.so.4()(64bit)
    libkio.so.5()(64bit)
    libkparts.so.4()(64bit)
    libktexteditor.so.4()(64bit)
    libm.so.6()(64bit)
    libnepomuk.so.4()(64bit)
    libnepomukutils.so.4()(64bit)
    libpthread.so.0()(64bit)
    libsoprano.so.4()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    rtld(GNU_HASH)



Provides
--------
kate-plugin-cpphelper:
    kate-plugin-cpphelper
    kate-plugin-cpphelper(x86-64)



Unversioned so-files
--------------------
kate-plugin-cpphelper: /usr/lib64/kde4/katecpphelperplugin.so

Source checksums
----------------
http://kde-apps.org/CONTENT/content-files/148606-KateCppHelperPlugin-0.9.3.tar.bz2 :
  CHECKSUM(SHA256) this package     : 766f92d87e6e70a0b5037959e69233245c41c796d6fb3d02ed15895b611f9352
  CHECKSUM(SHA256) upstream package : 766f92d87e6e70a0b5037959e69233245c41c796d6fb3d02ed15895b611f9352


Generated by fedora-review 0.5.0 (920221d) last change: 2013-08-30
Command line :/bin/fedora-review -b 1003156
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, SugarActivity, Perl, R, PHP, Ruby
Disabled flags: EPEL5, EXARCH, DISTTAG
Comment 2 Mario Blättermann 2013-09-26 14:30:01 EDT
Many thanks for the review! I will add a license text for the time being and get in contact with the upstream developer.


New Package SCM Request
=======================
Package Name: kate-plugin-cpphelper
Short Description: Plugin for Kate to simplify C/C++ programming
Owners: mariobl
Branches: f19 f20
Comment 3 Kevin Fenzi 2013-09-27 14:39:43 EDT
Git done (by process-git-requests).

Please do note: https://fedoraproject.org/wiki/Packaging:LicensingGuidelines#License_Text
before you include your own license text.
Comment 4 Fedora Update System 2013-09-27 15:11:17 EDT
kate-plugin-cpphelper-0.9.3-2.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/kate-plugin-cpphelper-0.9.3-2.fc19
Comment 5 Fedora Update System 2013-09-27 15:12:10 EDT
kate-plugin-cpphelper-0.9.3-2.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/kate-plugin-cpphelper-0.9.3-2.fc20
Comment 6 Sandro Mani 2013-09-28 05:32:02 EDT
Hi Mario,

You might want to backport parts of https://github.com/zaufi/kate-cpp-helper-plugin/commit/7e7b8632e9d5c01acc2fbd67ef212d3d027f0d22 , since currently kate crashes when the C++ Helper settings are opened.

Thanks,
Sandro
Comment 7 Kevin Kofler 2013-09-28 09:27:28 EDT
FYI, the guidelines recommend NOT adding license files where upstream failed to include them.
Comment 8 Fedora Update System 2013-09-28 21:24:48 EDT
kate-plugin-cpphelper-0.9.3-2.fc20 has been pushed to the Fedora 20 testing repository.
Comment 9 Fedora Update System 2013-10-08 07:28:16 EDT
kate-plugin-cpphelper-0.9.3-2.fc19 has been pushed to the Fedora 19 stable repository.
Comment 10 Fedora Update System 2013-10-09 10:38:08 EDT
kate-plugin-cpphelper-0.9.3-2.fc20 has been pushed to the Fedora 20 stable repository.

Note You need to log in before you can comment on or make changes to this bug.